"use strict";
{
    const SDK = self.SDK;

    const BEHAVIOR_ID = "spokoinbli_sphere";
    const BEHAVIOR_VERSION = "1.0.0.3";
    const BEHAVIOR_CATEGORY = "general";

    const BEHAVIOR_CLASS = SDK.Behaviors.spokoinbli_sphere = class sphereBehavior extends SDK.IBehaviorBase
    {
        constructor()
        {
            super(BEHAVIOR_ID);

            SDK.Lang.PushContext("behaviors." + BEHAVIOR_ID.toLowerCase());

            this._info.SetName(lang(".name"));
            this._info.SetDescription(lang(".description"));
            this._info.SetVersion(BEHAVIOR_VERSION);
            this._info.SetCategory(BEHAVIOR_CATEGORY);
            this._info.SetAuthor("spokoinbli");
            this._info.SetHelpUrl(lang(".help-url"));
            this._info.SetIsOnlyOneAllowed(true);
            this._info.SetCanBeBundled(true);

            this._info.SetSupportedRuntimes(["c3"]);



            SDK.Lang.PushContext(".properties");

            this._info.SetProperties([
              new SDK.PluginProperty("integer", "mesh", 25,
            {
                "interpolatable": false
            }),
              new SDK.PluginProperty("integer", "zElevation", 125,
            {
                "interpolatable": false
            }),
              new SDK.PluginProperty("check", "hemisphere", false,
            {
                interpolatable: false
            })
            ]);

            SDK.Lang.PopContext(); //.properties
            SDK.Lang.PopContext();
        }
    };

    BEHAVIOR_CLASS.Register(BEHAVIOR_ID, BEHAVIOR_CLASS);
}