"use strict";
{
    const C3 = self.C3;

    C3.Behaviors.spokoinbli_sphere.Instance = class sphereInstance extends C3.SDKBehaviorInstanceBase
    {
        constructor(behInst, properties)
        {
            super(behInst);

            //this._testProperty = 0;

            if (properties)
            {

                this.mesh = properties[0];
                this.zElevation = properties[1];
                this.hemisphere = properties[2];
            }

            // Opt-in to getting calls to Tick()
            this._StartTicking();
        }

        Release()
        {
            super.Release();
        }


        SaveToJson()
        {
            return {
                "mesh": this.mesh,
                "zElevation": this.zElevation,
                "hemisphere": this.hemisphere,
            };
        }

        LoadFromJson(o)
        {
            this.mesh = o.mesh;
            this.zElevation = o.zElevation;
            this.hemisphere = o.hemisphere;
        }


        Tick() // ... code to run every tick for this behavior ...
        {
            let draw = false;
            const wi = this._inst.GetWorldInfo();
            const width = wi.GetWidth();
            
            let hemisphere = this.hemisphere?0:1;
            let zSphere = this.zElevation;
            let meshColumns = this.mesh;
            let meshRows = Math.floor(meshColumns / 2) + 1;
            let degree = 360 / (meshColumns - 1);


            const updateMesh = meshColumns > 4;
            if (updateMesh)
            {
                wi.CreateMesh(meshColumns, meshRows);


                for (let i = 0; i < meshColumns; i++)
                {
                    for (let u = 0; u < meshRows; u++)
                    {

                        draw = wi.SetMeshPoint(i, u,
                        {
                            mode: "absolute",
                            x: 0.5 + 0.5 * Math.cos(C3.toRadians(i * degree + 90)) * Math.sin(C3.toRadians(u * degree)),
                            y: 0.5 - 0.5 * Math.cos(C3.toRadians(u * degree)),
                            zElevation: (hemisphere - Math.sin(C3.toRadians(i * degree + 90)) * Math.sin(C3.toRadians(u * degree))) * zSphere,
                            u: -1,
                            v: -1
                        })

                    }
                }
            }
            if (draw)
            {
                wi.SetBboxChanged();
            }
            this._StopTicking();

        }

        GetDebuggerProperties()
        {
            return [
            {
                title: "sphere",
                properties: [
                {
                    name: "mesh",
                    value: this.mesh,
                    onedit: v => this.setValue("mesh", v)},
               {
                    name: "zElevation",
                    value: this.zElevation,
                    onedit: v => this.setValue("zElevation", v)},
               {
                    name: "hemisphere",
                    value: this.hemisphere,
                    onedit: v => this.setValue("hemisphere", v)}
                
                ]
            }];
        }


        setValue(name, v)
        {
            this[name] = v;
            this._StartTicking();
        }

        GetPropertyValueByIndex(index)
        {
            return 0;
        }

        SetPropertyValueByIndex(index, value)
        {
            //set property value here
        }
    };
}